/* mug4.P,v 1.2 1993/11/24 18:43:33 uwe Exp */
/* Breitensuche in einem Baum            */
/* ohne Erklaerungskomponente            */

:-op(200,xfx,:).

writes(X:Y) :-
	write(X),
	write(':'),
	write(Y).

rule(X:Y, 4:Y) :- 
	X < 4,
        writes(4:Y).
rule(X:Y, X:3) :- 
	Y < 3,
        writes(X:3).
rule(X:Y, 0:Y) :- 
	X > 0,
        writes(0:Y).
rule(X:Y, X:0) :- 
	Y > 0,
        writes(X:0).
rule(X:Y, 4:Z) :- 
	X < 4, X + Y >= 4, 
	Z is X + Y - 4,
        writes(4:Z).
rule(X:Y, Z:3) :- 
	Y < 3, X + Y >= 3, 
	Z is X + Y - 3,
        writes(Z:3).
rule(X:Y, Z:0) :-
	Y > 0, X + Y < 4, 
	Z is X + Y,
        writes(Z:0).
rule(X:Y, 0:Z) :-
	X > 0, X + Y < 3, 
	Z is X + Y,
        writes(0:Z).
    
  
/* generiere alle Nachfolger aus einem Knoten */
  
gen1(S,L) :-
	findall(S1,rule(S,S1),L).

/* generiere alle Nachfolger aus einer Liste */
gen([],[]).
gen([S|T],Succ) :- 
	gen1(S,Succ1), 
        write('***'),
	gen(T,  Succ2),
	append(Succ1,Succ2,Succ).
  
append([],L,L).
append([H|R],L,[H|L1]) :-
	append(R,L,L1).

isin(S,[H|_]) :- S = H,!.
isin(S,[_|T]) :- isin(S,T).

solve(Statelist,G,_,_) :- 
	isin(G,Statelist), 
	!.

solve(_,_,Max,Max) :- 
	!, fail.

solve(Statelist,G,N,Max) :- 
	gen(Statelist,Succ),
        nl, 
	N1 is N + 1, 
	solve(Succ,G,N1,Max).

zweiliter(Max) :- 
	solve([0:0], 2:_, 0, Max), !.


