/* $Id: krug-as.pl,v 1.1 1995/12/01 20:01:54 uwe Exp $ */

/*--- Wasserkrugproblem mit A*-Algorithmus -------------- -----------------------------*/

:- asserta(
	(help :-
		write('Wasserkrugproblem mit A*-Algorithmus'), nl,
		write('Ziele:'), nl,
		write('   zweiliter(MaximaleAnzahlSchritte).'), nl,
		write('   zweiliter. (zweiliter(100))'), nl,
		write('   ziel.	-> Suche mit verschiedenen Kostenfunktionen'), nl,
		nl, fail)
	).

:- consult('astern_a.pl').
:- consult('krug-re.pl').
:- consult('krug-ko.pl').

:- traceon.

:- assertz((help :- true)).
:- help.

/*--- tests ---------------------------------------------------------------------------*/

zweiliter(Max) :- 
	solve(0:0,Max).

zweiliter :-
	zweiliter(100),
        nl.


ziel_1 :-
	wasserkosten, zweiliter.
ziel_2 :-
	bestensuche, zweiliter.
ziel_3 :-
	bestensuche1, zweiliter.


/*-------------------------------------------------------------------------------------*/
